﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static Filsonator.MainForm;
using static System.Net.Mime.MediaTypeNames;
using Image = System.Drawing.Image;

namespace Filsonator
{
    public partial class BlockForm : Form
    {
        public static Image imgDel = Image.FromFile(@"img\delete.png");
        public static string[] TextColor;
        public static new string[] BackColor;
        public static string[] BorderColor;
        public static Color text;
        public static Color background;
        public static Color border;
        public string textRGB;
        public string backgroundRGB;
        public string borderRGB;
        public static int fSize = 0;
        private MainForm mF;
        public BlockForm(MainForm mainForm)
        {
            InitializeComponent();
            mF = mainForm;
        }

        private void BlockForm_Load(object sender, EventArgs e)
        {
            button_Text_Paste.ForeColor = MainForm.textSaved;
            RootBlocks b = JsonConvert.DeserializeObject<RootBlocks>(File.ReadAllText($@"filson\{MainForm.blockFile}"));
            var bl = b.blocks[MainForm.blockIndex];

            //// Type
            comboBox_Type.Items.Add("All");
            comboBox_Type.Items.Add("Normal");
            comboBox_Type.Items.Add("Strict");
            comboBox_Type.Text = bl.Type;
            //// Show
            comboBox_Show.Items.Add("True");
            comboBox_Show.Items.Add("False");
            comboBox_Show.Text = bl.Show.ToString();
            //// Class
            if (bl.Class.Count >= 1)
            {
                foreach (var c in bl.Class)
                {
                    dataGridView_Class.Rows.Add(imgDel, c);
                }
            }
            //// Base
            if (bl.BaseType.Count >= 1)
            {
                foreach (var c in bl.BaseType)
                {
                    dataGridView_Base.Rows.Add(imgDel, c);
                }
            }           
            //// Font Size
            comboBox_FontSize.Items.Add("45");
            comboBox_FontSize.Items.Add("40");
            comboBox_FontSize.Items.Add("38");
            comboBox_FontSize.Items.Add("35");
            comboBox_FontSize.Items.Add("33");
            comboBox_FontSize.Items.Add("30");
            comboBox_FontSize.Items.Add("25");
            comboBox_FontSize.Text = bl.SetFontSize;
            //// In-Game Image
            TextColor = bl.SetTextColor[0].Split(' ');
            BackColor = bl.SetBackgroundColor[0].Split(' ');
            BorderColor = bl.SetBorderColor[0].Split(' ');
            fSize = Convert.ToInt16(bl.SetFontSize);
            text = Color.FromArgb(Convert.ToInt16(TextColor[0]), Convert.ToInt16(TextColor[1]), Convert.ToInt16(TextColor[2]));
            background = Color.FromArgb(Convert.ToInt16(BackColor[0]), Convert.ToInt16(BackColor[1]), Convert.ToInt16(BackColor[2]));
            border = Color.FromArgb(Convert.ToInt16(BorderColor[0]), Convert.ToInt16(BorderColor[1]), Convert.ToInt16(BorderColor[2]));
            pictureBox_InGame.Image = Utilities.Draw.DrawBlock(text, background, border, Convert.ToInt16(bl.SetFontSize));
            StructureForm.Settings j = JsonConvert.DeserializeObject<StructureForm.Settings>(File.ReadAllText("settings.json"));
            //// Condition
            DataGridViewImageColumn cDelIMG = new DataGridViewImageColumn();
            DataGridViewComboBoxColumn cbConditions = new DataGridViewComboBoxColumn();
            cbConditions.Name = "cbConditions";
            DataGridViewComboBoxColumn cbCOp = new DataGridViewComboBoxColumn();
            cbCOp.Name = "cbCOp";
            foreach (var o in j.Operators)
            {
                cbCOp.Items.Add(o);
            }
            foreach (var c in j.Conditions)
            {
                cbConditions.Items.Add(c);
            }
            dataGridView_Condition.Columns.Add(cDelIMG);
            dataGridView_Condition.Columns.Add(cbConditions);
            dataGridView_Condition.Columns.Add(cbCOp);
            dataGridView_Condition.Columns.Add("condValue", "condValue");
            foreach (var c in bl.Conditions)
            {
                
                dataGridView_Condition.Rows.Add(imgDel, c.name, c.op, c.value);
            }
            //// Action
            DataGridViewImageColumn aDelIMG = new DataGridViewImageColumn();
            DataGridViewComboBoxColumn cbVarA = new DataGridViewComboBoxColumn();
            cbVarA.Name = "cbVarA";
            DataGridViewComboBoxColumn cbVarB = new DataGridViewComboBoxColumn();
            cbVarB.Name = "cbVarB";
            DataGridViewComboBoxColumn cbVarC = new DataGridViewComboBoxColumn();
            cbVarC.Name = "cbVarC";
            DataGridViewComboBoxColumn cbActions = new DataGridViewComboBoxColumn();
            cbActions.Name = "cbAction";         
            cbVarA.Items.Add("## Sizes ##");
            foreach (var si in j.Sizes)
            {
                cbVarA.Items.Add(si);
            }
            cbVarA.Items.Add("## Colors ##");
            foreach (var c in j.Colors)
            {
                cbVarA.Items.Add(c);
            }
            cbVarA.Items.Add("## Sounds ##");
            var sf = Directory.GetFiles("sound");
            foreach (var s in sf)
            {
                string sn = Path.GetFileName(s);
                cbVarA.Items.Add(sn);
            }
            cbVarB.Items.Add("## PlayEffect ##");
            cbVarB.Items.Add("");
            cbVarB.Items.Add("Temp");
            cbVarB.Items.Add("## Colors ##");
            foreach (var c in j.Colors)
            {
                cbVarB.Items.Add(c);
            }
            cbVarC.Items.Add("## Colors ##");
            foreach (var c in j.Colors)
            {
                cbVarC.Items.Add(c);
            }
            cbVarC.Items.Add("## Shapes ##");
            foreach (var sh in j.Shapes)
            {
                cbVarC.Items.Add(sh);
            }
            foreach (var a in j.Actions)
            {
                cbActions.Items.Add(a);
            }
            dataGridView_Action.Columns.Add(aDelIMG);
            dataGridView_Action.Columns.Add(cbActions);
            dataGridView_Action.Columns.Add(cbVarA);
            dataGridView_Action.Columns.Add(cbVarB);
            dataGridView_Action.Columns.Add(cbVarC);
            foreach (var a in bl.Actions)
            {
                
                dataGridView_Action.Rows.Add(imgDel, a.name, a.va, a.vb, a.vc, a.vd);
            }
        }

        private void dataGridView_Condition_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dataGridView_Condition.CurrentCell.ColumnIndex.Equals(0))
            {
                dataGridView_Condition.Rows.RemoveAt(dataGridView_Condition.CurrentRow.Index);
            }
        }

        private void dataGridView_Action_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dataGridView_Action.CurrentCell.ColumnIndex.Equals(0))
            {
                dataGridView_Action.Rows.RemoveAt(dataGridView_Action.CurrentRow.Index);
            }
        }

        private void dataGridView_Class_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dataGridView_Class.CurrentCell.ColumnIndex.Equals(0))
            {
                dataGridView_Class.Rows.RemoveAt(dataGridView_Class.CurrentRow.Index);
            }
        }

        private void dataGridView_Base_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dataGridView_Base.CurrentCell.ColumnIndex.Equals(0))
            {
                dataGridView_Base.Rows.RemoveAt(dataGridView_Base.CurrentRow.Index);
            }
        }

        private void button_AddClass_Click(object sender, EventArgs e)
        {
            if (textBox_AddClass.Text != null)
            {
                dataGridView_Class.Rows.Add(imgDel, textBox_AddClass.Text);
                textBox_AddClass.Text = "";
            }
        }

        private void button_AddBase_Click(object sender, EventArgs e)
        {
            if (textBox_AddBase.Text != null)
            {
                dataGridView_Base.Rows.Add(imgDel, textBox_AddBase.Text);
                textBox_AddBase.Text = "";
            }
        }

        private void button_Color_Text_Click(object sender, EventArgs e)
        {
            ColorDialog colorDlg = new ColorDialog();
            colorDlg.AllowFullOpen = true;
            colorDlg.AnyColor = true;
            colorDlg.SolidColorOnly = false;
            colorDlg.Color = text;

            if (colorDlg.ShowDialog() == DialogResult.OK)
            {              
                pictureBox_InGame.Image = Utilities.Draw.DrawBlock(colorDlg.Color, background, border, fSize);
                text = colorDlg.Color;
            }
        }

        private void button_Color_Back_Click(object sender, EventArgs e)
        {
            ColorDialog colorDlg = new ColorDialog();
            colorDlg.AllowFullOpen = true;
            colorDlg.AnyColor = true;
            colorDlg.SolidColorOnly = false;
            colorDlg.Color = background;

            if (colorDlg.ShowDialog() == DialogResult.OK)
            {
                pictureBox_InGame.Image = Utilities.Draw.DrawBlock(text, colorDlg.Color, border, fSize);
                background = colorDlg.Color;
            }
        }

        private void button_Color_Border_Click(object sender, EventArgs e)
        {
            ColorDialog colorDlg = new ColorDialog();
            colorDlg.AllowFullOpen = true;
            colorDlg.AnyColor = true;
            colorDlg.SolidColorOnly = false;
            colorDlg.Color = border;

            if (colorDlg.ShowDialog() == DialogResult.OK)
            {
                pictureBox_InGame.Image = Utilities.Draw.DrawBlock(text, background, colorDlg.Color, fSize);
                border = colorDlg.Color;
            }
        }

        private void comboBox_FontSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            fSize = Convert.ToInt16(comboBox_FontSize.Text);
            pictureBox_InGame.Image = Utilities.Draw.DrawBlock(text, background, border, fSize);
        }

        private void button_Save_Click(object sender, EventArgs e)
        {
            //// Write to the selected json file
            string json = File.ReadAllText($@"filson\{MainForm.blockFile}");
            dynamic jo = JsonConvert.DeserializeObject(json);
            //// Type
            jo["blocks"][MainForm.blockIndex]["Type"] = comboBox_Type.Text;
            //// Show
            jo["blocks"][MainForm.blockIndex]["Show"] = comboBox_Show.Text;
            //// Class
            if (dataGridView_Class.Rows.Count >= 1)
            {
                JArray classes = new JArray();
                foreach (DataGridViewRow row in dataGridView_Class.Rows)
                {
                    classes.Add(row.Cells[1].Value.ToString());                
                }
                jo["blocks"][MainForm.blockIndex]["Class"] = classes;
            }                      
            //// Base
            if (dataGridView_Base.Rows.Count >= 1)
            {
                JArray bases = new JArray();
                foreach (DataGridViewRow row in dataGridView_Base.Rows)
                {
                    bases.Add(row.Cells[1].Value.ToString());                      
                }
                jo["blocks"][MainForm.blockIndex]["BaseType"] = bases;
            }
            //// SetTextColor
            JArray textColor = new JArray();
            textColor.Add($"{text.R} {text.G} {text.B}");
            jo["blocks"][MainForm.blockIndex]["SetTextColor"] = textColor;
            //// SetBackgroundColor
            JArray backColor = new JArray();
            backColor.Add($"{background.R} {background.G} {background.B}");
            jo["blocks"][MainForm.blockIndex]["SetBackgroundColor"] = backColor;
            //// SetBorderColor
            JArray borderColor = new JArray();
            borderColor.Add($"{border.R} {border.G} {border.B}");
            jo["blocks"][MainForm.blockIndex]["SetBorderColor"] = borderColor;           
            //// Conditions
            JArray condition = new JArray();
            foreach(DataGridViewRow row in dataGridView_Condition.Rows)
            {
                JObject cond = JObject.FromObject(new
                {
                    name = row.Cells["cbConditions"].Value,
                    op = row.Cells["cbCOp"].Value,
                    value = row.Cells["condValue"].Value
                });
                condition.Add(cond);
            }
            jo["blocks"][MainForm.blockIndex]["Conditions"] = condition;
            //// Actions
            JArray actions = new JArray();
            foreach (DataGridViewRow row in dataGridView_Action.Rows)
            {
                JObject bas = JObject.FromObject(new
                {
                    name = row.Cells["cbAction"].Value,
                    va = row.Cells["cbVarA"].Value,
                    vb = row.Cells["cbVarB"].Value,
                    vc = row.Cells["cbVarC"].Value
                });
                actions.Add(bas);
            }
            jo["blocks"][MainForm.blockIndex]["Actions"] = actions;
            //// FontSize
            jo["blocks"][MainForm.blockIndex]["SetFontSize"] = comboBox_FontSize.Text;
            //// WRITE
            string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
            File.WriteAllText($@"filson\{MainForm.blockFile}", output);
            //// Update Block List
            mF.UpdateBlockList();
            //// Done
            this.Close();
        }

        private void button_Text_Copy_Click(object sender, EventArgs e)
        {
            RootBlocks b = JsonConvert.DeserializeObject<RootBlocks>(File.ReadAllText($@"filson\{MainForm.blockFile}"));
            var bl = b.blocks[MainForm.blockIndex];
            TextColor = bl.SetTextColor[0].Split(' ');
            MainForm.textSaved = Color.FromArgb(Convert.ToInt16(TextColor[0]), Convert.ToInt16(TextColor[1]), Convert.ToInt16(TextColor[2]));
            button_Text_Paste.ForeColor = Color.FromArgb(Convert.ToInt16(TextColor[0]), Convert.ToInt16(TextColor[1]), Convert.ToInt16(TextColor[2]));
        }

        private void button_Text_Paste_Click(object sender, EventArgs e)
        {
            //// Write to the selected json file
            string json = File.ReadAllText($@"filson\{MainForm.blockFile}");
            dynamic jo = JsonConvert.DeserializeObject(json);
            JArray textColor = new JArray();
            textColor.Add($"{MainForm.textSaved.R} {MainForm.textSaved.G} {MainForm.textSaved.B}");
            jo["blocks"][MainForm.blockIndex]["SetTextColor"] = textColor;
            //// WRITE
            string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
            File.WriteAllText($@"filson\{MainForm.blockFile}", output);
            mF.UpdateBlockList();
            pictureBox_InGame.Image = Utilities.Draw.DrawBlock(MainForm.textSaved, background, border, fSize);
            text = MainForm.textSaved;
        }

        private void button_Back_Copy_Click(object sender, EventArgs e)
        {
            RootBlocks b = JsonConvert.DeserializeObject<RootBlocks>(File.ReadAllText($@"filson\{MainForm.blockFile}"));
            var bl = b.blocks[MainForm.blockIndex];
            BackColor = bl.SetBackgroundColor[0].Split(' ');
            MainForm.backSaved = Color.FromArgb(Convert.ToInt16(BackColor[0]), Convert.ToInt16(BackColor[1]), Convert.ToInt16(BackColor[2]));
            button_Back_Paste.ForeColor = Color.FromArgb(Convert.ToInt16(BackColor[0]), Convert.ToInt16(BackColor[1]), Convert.ToInt16(BackColor[2]));
        }

        private void button_Back_Paste_Click(object sender, EventArgs e)
        {
            //// Write to the selected json file
            string json = File.ReadAllText($@"filson\{MainForm.blockFile}");
            dynamic jo = JsonConvert.DeserializeObject(json);
            JArray backColor = new JArray();
            backColor.Add($"{MainForm.backSaved.R} {MainForm.backSaved.G} {MainForm.backSaved.B}");
            jo["blocks"][MainForm.blockIndex]["SetBackgroundColor"] = backColor;
            //// WRITE
            string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
            File.WriteAllText($@"filson\{MainForm.blockFile}", output);
            mF.UpdateBlockList();
            pictureBox_InGame.Image = Utilities.Draw.DrawBlock(text, MainForm.backSaved, border, fSize);
            background = MainForm.backSaved;
        }

        private void button_Border_Copy_Click(object sender, EventArgs e)
        {
            RootBlocks b = JsonConvert.DeserializeObject<RootBlocks>(File.ReadAllText($@"filson\{MainForm.blockFile}"));
            var bl = b.blocks[MainForm.blockIndex];
            BorderColor = bl.SetBorderColor[0].Split(' ');
            MainForm.borderSaved = Color.FromArgb(Convert.ToInt16(BorderColor[0]), Convert.ToInt16(BorderColor[1]), Convert.ToInt16(BorderColor[2]));
            button_Border_Paste.ForeColor = Color.FromArgb(Convert.ToInt16(BorderColor[0]), Convert.ToInt16(BorderColor[1]), Convert.ToInt16(BorderColor[2]));
        }

        private void button_Border_Paste_Click(object sender, EventArgs e)
        {
            //// Write to the selected json file
            string json = File.ReadAllText($@"filson\{MainForm.blockFile}");
            dynamic jo = JsonConvert.DeserializeObject(json);
            JArray borderColor = new JArray();
            borderColor.Add($"{MainForm.borderSaved.R} {MainForm.borderSaved.G} {MainForm.borderSaved.B}");
            jo["blocks"][MainForm.blockIndex]["SetBorderColor"] = borderColor;
            //// WRITE
            string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
            File.WriteAllText($@"filson\{MainForm.blockFile}", output);
            mF.UpdateBlockList();
            pictureBox_InGame.Image = Utilities.Draw.DrawBlock(text, background, MainForm.backSaved, fSize);
            border = MainForm.backSaved;
        }

        private void button_Close_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void pictureBox_AddCondition_Click(object sender, EventArgs e)
        {
            dataGridView_Condition.Rows.Add(imgDel,"","");
        }

        private void pictureBox_AddAction_Click(object sender, EventArgs e)
        {
            dataGridView_Action.Rows.Add(imgDel, "", "", "");
        }
    }
}
