﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Diagnostics.Eventing.Reader;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net.NetworkInformation;
using System.Runtime.InteropServices;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml.Linq;
using static Filsonator.MainForm;
using static System.Net.Mime.MediaTypeNames;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.TrayNotify;

namespace Filsonator
{
    public partial class MainForm : Form
    {
        public class Block
        {
            public string Type { get; set; }
            public bool Show { get; set; }
            public List<string> Class { get; set; }
            public List<string> BaseType { get; set; }
            public List<string> SetTextColor { get; set; }
            public List<string> SetBackgroundColor { get; set; }
            public List<string> SetBorderColor { get; set; }
            public string SetFontSize { get; set; }
            public List<Condition> Conditions { get; set; }
            public List<Action> Actions { get; set; }
        }

        public class Condition
        {
            public string name { get; set; }
            public string op { get; set; }
            public string value { get; set; }
        }

        public class Action
        {
            public string name { get; set; }
            public string va { get; set; }
            public string vb { get; set; }
            public string vc { get; set; }
            public string vd { get; set; }
        }

        public class RootBlocks
        {
            public List<Block> blocks { get; set; }
        }

        public static string version = "1.0.0";
        public static string revision = "#532g23hj";
        public static int blockIndex = 0;
        public static string blockFile = "";
        public static Color textSaved = Color.Black;
        public static Color backSaved;
        public static Color borderSaved;
        public static string jSType = "";
        public static string jSShow = "";
        public static JArray jLClass = new JArray();
        public static JArray jLBaseType = new JArray();
        public static JArray jLSetTextColor = new JArray();
        public static JArray jLSetBackgroundColor = new JArray();
        public static JArray jLSetBorderColor = new JArray();
        public static string jSFontSize = "";
        public static JArray jAConditions = new JArray();
        public static JArray jAActions = new JArray();
        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            this.Text = $"Filsonator v{version}";
            toolStripStatusLabel_Main_Label.Text = $"Dev by mikx (mxpoe.ovh)";
            Color cellback = ColorTranslator.FromHtml("#1c1c1c");
            Color cellborder = ColorTranslator.FromHtml("#242424");
            Color cellheader = ColorTranslator.FromHtml("#1f1f1f");
            dataGrid_Main_BlockList.DefaultCellStyle.BackColor = cellback;
            dataGrid_Main_BlockList.DefaultCellStyle.SelectionBackColor = cellback;
            dataGrid_Main_BlockList.DefaultCellStyle.ForeColor = Color.White;
            dataGrid_Main_BlockList.GridColor = cellborder;
            dataGrid_Main_BlockList.EnableHeadersVisualStyles = false;
            dataGrid_Main_BlockList.ColumnHeadersDefaultCellStyle.BackColor = cellheader;
            dataGrid_Main_BlockList.ColumnHeadersDefaultCellStyle.ForeColor = Color.White;

            /// Populate the combobox with the filson files
            var ff = Directory.GetFiles("filson");
            foreach ( var f in ff )
            {
                string fn = Path.GetFileName(f);
                comboBox_FilsonFiles.Items.Add(fn);
            }
        }

        private void comboBox_FilsonFiles_SelectedIndexChanged(object sender, EventArgs e)
        {
            UpdateBlockList();
        }

        private void dataGrid_Main_BlockList_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dataGrid_Main_BlockList.CurrentCell.ColumnIndex.Equals(1))
            {
                DialogResult dr = MessageBox.Show("Sould we delete this block?", "Confirmation", MessageBoxButtons.YesNo);
                if (dr == DialogResult.Yes)
                {
                    dataGrid_Main_BlockList.Rows.RemoveAt(dataGrid_Main_BlockList.CurrentRow.Index);
                }
                else if (DialogResult == DialogResult.No)
                {
                    //Nothing to do
                }                
            }
            if (dataGrid_Main_BlockList.CurrentCell.ColumnIndex.Equals(2))
            {
                blockIndex = Convert.ToInt16(dataGrid_Main_BlockList.CurrentRow.Cells[0].Value);
                blockFile = comboBox_FilsonFiles.Text;
                BlockForm bf = new BlockForm(this);
                bf.Show();
            }
            if (dataGrid_Main_BlockList.CurrentCell.ColumnIndex.Equals(3))
            {
                int bc = dataGrid_Main_BlockList.Rows.Count - 1;
                int bwn = bc + 1;
                dataGrid_Main_BlockList.Rows.Add(bwn, System.Drawing.Image.FromFile(@"img\deletelist.png"), System.Drawing.Image.FromFile(@"img\ListEdit.png"), System.Drawing.Image.FromFile(@"img\ListCopy.png"), Utilities.Draw.DrawBlock(Color.Black, Color.White, Color.Gray, 30), "All", "True", "Items", "", "0 0 0", "0 0 0", "0 0 0", "30");
                CopyBlockFromGridView(Convert.ToInt16(dataGrid_Main_BlockList.CurrentRow.Cells[0].Value));
            }
        }

        public void UpdateBlockList()
        {
            dataGrid_Main_BlockList.Rows.Clear();
            dataGrid_Main_BlockList.RowTemplate.Height = 40;
            blockFile = comboBox_FilsonFiles.Text;
            RootBlocks bl = JsonConvert.DeserializeObject<RootBlocks>(File.ReadAllText($@"filson\{comboBox_FilsonFiles.Text}"));
            toolStripStatusLabel_Main_Label.Text = $"{bl.blocks.Count} Blocks";
            int max = bl.blocks.Count;
            int current = 0;
            string classes = "";
            string bases = "";
            foreach (var b in bl.blocks)
            {
                foreach (var cl in b.Class)
                {
                    classes += $"{cl} ";
                }
                foreach (var ba in b.BaseType)
                {
                    bases += $"{ba} ";
                }
                string[] TextColor = b.SetTextColor[0].Split(' ');
                string[] BackColor = b.SetBackgroundColor[0].Split(' ');
                string[] BorderColor = b.SetBorderColor[0].Split(' ');
                Color text = Color.FromArgb(Convert.ToInt16(TextColor[0]), Convert.ToInt16(TextColor[1]), Convert.ToInt16(TextColor[2]));
                Color background = Color.FromArgb(Convert.ToInt16(BackColor[0]), Convert.ToInt16(BackColor[1]), Convert.ToInt16(BackColor[2]));
                Color border = Color.FromArgb(Convert.ToInt16(BorderColor[0]), Convert.ToInt16(BorderColor[1]), Convert.ToInt16(BorderColor[2]));
                string conditionsMulti = "";
                foreach (var c in b.Conditions)
                {
                    conditionsMulti += $"{c.name} {c.op} {c.value}{Environment.NewLine}";
                }
                string actionsMulti = "";
                foreach (var a in b.Actions)
                {
                    actionsMulti += $"{a.name} {a.va} {a.vb} {a.vc} {a.vd}{Environment.NewLine}";
                }
                dataGrid_Main_BlockList.Columns[6].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dataGrid_Main_BlockList.Columns["col10"].MinimumWidth = 100;
                dataGrid_Main_BlockList.Columns[7].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dataGrid_Main_BlockList.Columns["col11"].MinimumWidth = 100;
                dataGrid_Main_BlockList.Rows.Add(current, System.Drawing.Image.FromFile(@"img\deletelist.png"), System.Drawing.Image.FromFile(@"img\ListEdit.png"), System.Drawing.Image.FromFile(@"img\ListCopy.png"), Utilities.Draw.DrawBlock(text, background, border, Convert.ToInt16(b.SetFontSize)), b.Type, b.Show, conditionsMulti, actionsMulti, classes, bases, b.SetTextColor[0], b.SetBackgroundColor[0], b.SetBorderColor[0], b.SetFontSize);
                current++;
                classes = "";
                bases = "";
            }
        }

        public void UpdateBlockOrder()
        {

        }

        private void button_Generate_Click(object sender, EventArgs e)
        {
            Process p = new Process();
            p.StartInfo.FileName = "mxfiltergen.exe";
            p.Start();
            this.Close();
        }

        private void button_Compile_Click(object sender, EventArgs e)
        {
            Process p = new Process();
            p.StartInfo.FileName = "mxfiltergen.exe";
            p.StartInfo.Arguments = "--compile";
            p.Start();
            this.Close();
        }

        private Rectangle dragBoxFromMouseDown;
        private int rowIndexFromMouseDown;
        private int rowIndexOfItemUnderMouseToDrop;

        private void dataGrid_Main_BlockList_MouseMove(object sender, MouseEventArgs e)
        {
            if ((e.Button & MouseButtons.Left) == MouseButtons.Left)
            {
                // If the mouse moves outside the rectangle, start the drag.
                if (dragBoxFromMouseDown != Rectangle.Empty &&
                !dragBoxFromMouseDown.Contains(e.X, e.Y))
                {
                    // Proceed with the drag and drop, passing in the list item.                    
                    DragDropEffects dropEffect = dataGrid_Main_BlockList.DoDragDrop(
                          dataGrid_Main_BlockList.Rows[rowIndexFromMouseDown],
                          DragDropEffects.Move);
                }
            }
        }

        private void dataGrid_Main_BlockList_MouseDown(object sender, MouseEventArgs e)
        {
            // Get the index of the item the mouse is below.
            rowIndexFromMouseDown = dataGrid_Main_BlockList.HitTest(e.X, e.Y).RowIndex;

            if (rowIndexFromMouseDown != -1)
            {
                // Remember the point where the mouse down occurred. 
                // The DragSize indicates the size that the mouse can move 
                // before a drag event should be started.                
                Size dragSize = SystemInformation.DragSize;

                // Create a rectangle using the DragSize, with the mouse position being
                // at the center of the rectangle.
                dragBoxFromMouseDown = new Rectangle(
                          new Point(
                            e.X - (dragSize.Width / 2),
                            e.Y - (dragSize.Height / 2)),
                      dragSize);
            }
            else
                // Reset the rectangle if the mouse is not over an item in the ListBox.
                dragBoxFromMouseDown = Rectangle.Empty;
        }

        private void dataGrid_Main_BlockList_DragOver(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        private void dataGrid_Main_BlockList_DragDrop(object sender, DragEventArgs e)
        {
            // The mouse locations are relative to the screen, so they must be 
            // converted to client coordinates.
            Point clientPoint = dataGrid_Main_BlockList.PointToClient(new Point(e.X, e.Y));

            // Get the row index of the item the mouse is below. 
            rowIndexOfItemUnderMouseToDrop = dataGrid_Main_BlockList.HitTest(clientPoint.X, clientPoint.Y).RowIndex;

            // If the drag operation was a move then remove and insert the row.
            if (e.Effect == DragDropEffects.Move)
            {
                DataGridViewRow rowToMove = e.Data.GetData(typeof(DataGridViewRow)) as DataGridViewRow;
                dataGrid_Main_BlockList.Rows.RemoveAt(rowIndexFromMouseDown);
                dataGrid_Main_BlockList.Rows.Insert(rowIndexOfItemUnderMouseToDrop, rowToMove);

            }
        }

        private void button_Save_Click(object sender, EventArgs e)
        {
            SaveBlocks();
        }

        private void button_AddBlock_Click(object sender, EventArgs e)
        {
            int bc = dataGrid_Main_BlockList.Rows.Count - 1;
            int bwn = bc + 1;
            dataGrid_Main_BlockList.Rows.Add(bwn, System.Drawing.Image.FromFile(@"img\deletelist.png"), System.Drawing.Image.FromFile(@"img\ListEdit.png"), System.Drawing.Image.FromFile(@"img\ListCopy.png"), Utilities.Draw.DrawBlock(Color.Black, Color.White, Color.Gray, 30), "All", "True", "Items", "", "0 0 0", "0 0 0", "0 0 0", "30");
            AddBlockFromGridView();
            UpdateBlockList();
        }

        public void SaveBlocks()
        {
            String json = File.ReadAllText($@"filson\{MainForm.blockFile}");
            dynamic jo = JsonConvert.DeserializeObject(json);
            JArray blocks = new JArray();
            foreach (DataGridViewRow row in dataGrid_Main_BlockList.Rows)
            {
                string bjson = File.ReadAllText($@"filson\{MainForm.blockFile}");
                dynamic bjo = JsonConvert.DeserializeObject(json);
                //// Save to JArray for re-order
                jSType = bjo["blocks"][row.Cells[0].Value]["Type"];
                jSShow = bjo["blocks"][row.Cells[0].Value]["Show"];
                jLClass = bjo["blocks"][row.Cells[0].Value]["Class"];
                jLBaseType = bjo["blocks"][row.Cells[0].Value]["BaseType"];
                jLSetTextColor = bjo["blocks"][row.Cells[0].Value]["SetTextColor"];
                jLSetBackgroundColor = bjo["blocks"][row.Cells[0].Value]["SetBackgroundColor"];
                jLSetBorderColor = bjo["blocks"][row.Cells[0].Value]["SetBorderColor"]; ;
                jSFontSize = bjo["blocks"][row.Cells[0].Value]["SetFontSize"];
                foreach (var condition in bjo["blocks"][row.Cells[0].Value]["Conditions"])
                {
                    JObject cond = JObject.FromObject(new
                    {
                        name = condition.name,
                        op = condition.op,
                        value = condition.value
                    });
                    jAConditions.Add(cond);
                }
                foreach (var action in bjo["blocks"][row.Cells[0].Value]["Actions"])
                {
                    JObject act = JObject.FromObject(new
                    {
                        name = action.name,
                        va = action.va,
                        vb = action.vb,
                        vc = action.vc,
                        vd = action.vd
                    });
                    jAActions.Add(act);
                }
                ////////////////////////////////                
                JObject bas = JObject.FromObject(new
                {
                    Type = jSType,
                    Show = jSShow,
                    Class = jLClass,
                    BaseType = jLBaseType,
                    SetTextColor = jLSetTextColor,
                    SetBackgroundColor = jLSetBackgroundColor,
                    SetBorderColor = jLSetBorderColor,
                    SetFontSize = jSFontSize,
                    Conditions = jAConditions,
                    Actions = jAActions
                });
                blocks.Add(bas);
                jLClass.Clear();
                jLBaseType.Clear();
                jLSetTextColor.Clear();
                jLSetBackgroundColor.Clear();
                jLSetBorderColor.Clear();
                jAConditions.Clear();
                jAActions.Clear();
            }
            jo["blocks"] = blocks;
            string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
            File.WriteAllText($@"filson\{MainForm.blockFile}", output);
            UpdateBlockList();
        }

        public void CopyBlockFromGridView(int rowIndex)
        {
            string[] empty = { };
            string[] colorw = { "255 255 255" };
            string[] colorb = { "0 0 0" };
            String json = File.ReadAllText($@"filson\{MainForm.blockFile}");
            dynamic jo = JsonConvert.DeserializeObject(json);
            JArray blocks = new JArray();
            int bc = dataGrid_Main_BlockList.Rows.Count;
            int cb = 1;
            foreach (DataGridViewRow row in dataGrid_Main_BlockList.Rows)
            {
                if (cb < bc)
                {
                    cb++;
                    string bjson = File.ReadAllText($@"filson\{MainForm.blockFile}");
                    dynamic bjo = JsonConvert.DeserializeObject(json);
                    //// Save to JArray for re-order
                    jSType = bjo["blocks"][row.Cells[0].Value]["Type"];
                    jSShow = bjo["blocks"][row.Cells[0].Value]["Show"];
                    jLClass = bjo["blocks"][row.Cells[0].Value]["Class"];
                    jLBaseType = bjo["blocks"][row.Cells[0].Value]["BaseType"];
                    jLSetTextColor = bjo["blocks"][row.Cells[0].Value]["SetTextColor"];
                    jLSetBackgroundColor = bjo["blocks"][row.Cells[0].Value]["SetBackgroundColor"];
                    jLSetBorderColor = bjo["blocks"][row.Cells[0].Value]["SetBorderColor"]; ;
                    jSFontSize = bjo["blocks"][row.Cells[0].Value]["SetFontSize"];
                    foreach (var condition in bjo["blocks"][row.Cells[0].Value]["Conditions"])
                    {
                        JObject cond = JObject.FromObject(new
                        {
                            name = condition.name,
                            op = condition.op,
                            value = condition.value
                        });
                        jAConditions.Add(cond);
                    }
                    foreach (var action in bjo["blocks"][row.Cells[0].Value]["Actions"])
                    {
                        JObject act = JObject.FromObject(new
                        {
                            name = action.name,
                            va = action.va,
                            vb = action.vb,
                            vc = action.vc,
                            vd = action.vd
                        });
                        jAActions.Add(act);
                    }
                    ////////////////////////////////                
                    JObject bas = JObject.FromObject(new
                    {
                        Type = jSType,
                        Show = jSShow,
                        Class = jLClass,
                        BaseType = jLBaseType,
                        SetTextColor = jLSetTextColor,
                        SetBackgroundColor = jLSetBackgroundColor,
                        SetBorderColor = jLSetBorderColor,
                        SetFontSize = jSFontSize,
                        Conditions = jAConditions,
                        Actions = jAActions
                    });
                    blocks.Add(bas);
                    jLClass.Clear();
                    jLBaseType.Clear();
                    jLSetTextColor.Clear();
                    jLSetBackgroundColor.Clear();
                    jLSetBorderColor.Clear();
                    jAConditions.Clear();
                    jAActions.Clear();
                    jo["blocks"] = blocks;
                    string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
                    File.WriteAllText($@"filson\{MainForm.blockFile}", output);
                }
                else
                {
                    string bjson = File.ReadAllText($@"filson\{MainForm.blockFile}");
                    dynamic bjo = JsonConvert.DeserializeObject(json);
                    //// Save to JArray for re-order
                    jSType = bjo["blocks"][rowIndex]["Type"];
                    jSShow = bjo["blocks"][rowIndex]["Show"];
                    jLClass = bjo["blocks"][rowIndex]["Class"];
                    jLBaseType = bjo["blocks"][rowIndex]["BaseType"];
                    jLSetTextColor = bjo["blocks"][rowIndex]["SetTextColor"];
                    jLSetBackgroundColor = bjo["blocks"][rowIndex]["SetBackgroundColor"];
                    jLSetBorderColor = bjo["blocks"][rowIndex]["SetBorderColor"]; ;
                    jSFontSize = bjo["blocks"][rowIndex]["SetFontSize"];
                    foreach (var condition in bjo["blocks"][rowIndex]["Conditions"])
                    {
                        JObject cond = JObject.FromObject(new
                        {
                            name = condition.name,
                            op = condition.op,
                            value = condition.value
                        });
                        jAConditions.Add(cond);
                    }
                    foreach (var action in bjo["blocks"][rowIndex]["Actions"])
                    {
                        JObject act = JObject.FromObject(new
                        {
                            name = action.name,
                            va = action.va,
                            vb = action.vb,
                            vc = action.vc,
                            vd = action.vd
                        });
                        jAActions.Add(act);
                    }
                    ////////////////////////////////                
                    JObject bas = JObject.FromObject(new
                    {
                        Type = jSType,
                        Show = jSShow,
                        Class = jLClass,
                        BaseType = jLBaseType,
                        SetTextColor = jLSetTextColor,
                        SetBackgroundColor = jLSetBackgroundColor,
                        SetBorderColor = jLSetBorderColor,
                        SetFontSize = jSFontSize,
                        Conditions = jAConditions,
                        Actions = jAActions
                    });
                    blocks.Add(bas);
                    jLClass.Clear();
                    jLBaseType.Clear();
                    jLSetTextColor.Clear();
                    jLSetBackgroundColor.Clear();
                    jLSetBorderColor.Clear();
                    jAConditions.Clear();
                    jAActions.Clear();
                    jo["blocks"] = blocks;
                    string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
                    File.WriteAllText($@"filson\{MainForm.blockFile}", output);
                }
            }
            UpdateBlockList();
        }

        public void AddBlockFromGridView()
        {
            string[] empty = { };
            string[] colorw = { "255 255 255" };
            string[] colorb = { "0 0 0" };
            String json = File.ReadAllText($@"filson\{MainForm.blockFile}");
            dynamic jo = JsonConvert.DeserializeObject(json);
            JArray blocks = new JArray();
            int bc = dataGrid_Main_BlockList.Rows.Count;
            int cb = 1;
            foreach (DataGridViewRow row in dataGrid_Main_BlockList.Rows)
            {
                if (cb < bc)
                {
                    cb++;
                    string bjson = File.ReadAllText($@"filson\{MainForm.blockFile}");
                    dynamic bjo = JsonConvert.DeserializeObject(json);
                    //// Save to JArray for re-order
                    jSType = bjo["blocks"][row.Cells[0].Value]["Type"];
                    jSShow = bjo["blocks"][row.Cells[0].Value]["Show"];
                    jLClass = bjo["blocks"][row.Cells[0].Value]["Class"];
                    jLBaseType = bjo["blocks"][row.Cells[0].Value]["BaseType"];
                    jLSetTextColor = bjo["blocks"][row.Cells[0].Value]["SetTextColor"];
                    jLSetBackgroundColor = bjo["blocks"][row.Cells[0].Value]["SetBackgroundColor"];
                    jLSetBorderColor = bjo["blocks"][row.Cells[0].Value]["SetBorderColor"]; ;
                    jSFontSize = bjo["blocks"][row.Cells[0].Value]["SetFontSize"];
                    foreach (var condition in bjo["blocks"][row.Cells[0].Value]["Conditions"])
                    {
                        JObject cond = JObject.FromObject(new
                        {
                            name = condition.name,
                            op = condition.op,
                            value = condition.value
                        });
                        jAConditions.Add(cond);
                    }
                    foreach (var action in bjo["blocks"][row.Cells[0].Value]["Actions"])
                    {
                        JObject act = JObject.FromObject(new
                        {
                            name = action.name,
                            va = action.va,
                            vb = action.vb,
                            vc = action.vc,
                            vd = action.vd
                        });
                        jAActions.Add(act);
                    }
                    ////////////////////////////////                
                    JObject bas = JObject.FromObject(new
                    {
                        Type = jSType,
                        Show = jSShow,
                        Class = jLClass,
                        BaseType = jLBaseType,
                        SetTextColor = jLSetTextColor,
                        SetBackgroundColor = jLSetBackgroundColor,
                        SetBorderColor = jLSetBorderColor,
                        SetFontSize = jSFontSize,
                        Conditions = jAConditions,
                        Actions = jAActions
                    });
                    blocks.Add(bas);
                    jLClass.Clear();
                    jLBaseType.Clear();
                    jLSetTextColor.Clear();
                    jLSetBackgroundColor.Clear();
                    jLSetBorderColor.Clear();
                    jAConditions.Clear();
                    jAActions.Clear();
                    jo["blocks"] = blocks;
                    string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
                    File.WriteAllText($@"filson\{MainForm.blockFile}", output);
                }  else
                {
                    string bjson = File.ReadAllText($@"filson\{MainForm.blockFile}");
                    dynamic bjo = JsonConvert.DeserializeObject(json);
                    //// Save to JArray for re-order
                    jSType = "All";
                    jSShow = "True";
                    jLClass = JArray.FromObject(empty);
                    jLBaseType = JArray.FromObject(empty);
                    jLSetTextColor = JArray.FromObject(colorw);
                    jLSetBackgroundColor = JArray.FromObject(colorb);
                    jLSetBorderColor = JArray.FromObject(colorw);
                    jSFontSize = "35";
                    JObject cond = JObject.FromObject(new
                    {
                        name = "",
                        op = "",
                        value = ""
                    });
                    jAConditions.Add(cond);
                    JObject act = JObject.FromObject(new
                    {
                        name = "",
                        va = "",
                        vb = "",
                        vc = "",
                        vd = ""
                    });
                    jAActions.Add(act);
                    ////////////////////////////////                
                    JObject bas = JObject.FromObject(new
                    {
                        Type = jSType,
                        Show = jSShow,
                        Class = jLClass,
                        BaseType = jLBaseType,
                        SetTextColor = jLSetTextColor,
                        SetBackgroundColor = jLSetBackgroundColor,
                        SetBorderColor = jLSetBorderColor,
                        SetFontSize = jSFontSize,
                        Conditions = jAConditions,
                        Actions = jAActions
                    });
                    blocks.Add(bas);
                    jLClass.Clear();
                    jLBaseType.Clear();
                    jLSetTextColor.Clear();
                    jLSetBackgroundColor.Clear();
                    jLSetBorderColor.Clear();
                    jAConditions.Clear();
                    jAActions.Clear();
                    jo["blocks"] = blocks;
                    string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
                    File.WriteAllText($@"filson\{MainForm.blockFile}", output);
                }              
            }           
            UpdateBlockList();
        }

        private void button_Structures_Click(object sender, EventArgs e)
        {
            StructureForm structureForm = new StructureForm();
            structureForm.Show();
        }

        private void button_Tiers_Click(object sender, EventArgs e)
        {
            TierForm tierForm = new TierForm();
            tierForm.Show();
        }

        private void button_Settings_Click(object sender, EventArgs e)
        {
            SettingForm settingForm = new SettingForm();
            settingForm.Show();
        }
    }
}
