﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Filsonator
{
    public partial class TierForm : Form
    {
        public static Image imgDel = Image.FromFile(@"img\delete.png");

        public TierForm()
        {
            InitializeComponent();
        }

        private void TierForm_Load(object sender, EventArgs e)
        {
            StructureForm.Settings j = JsonConvert.DeserializeObject<StructureForm.Settings>(File.ReadAllText("settings.json"));
            checkBox_OneHandAxe.Checked = j.tier1HAxe;
            checkBox_TwoHandAxe.Checked = j.tier2HAxe;
            checkBox_OneHandMace.Checked = j.tier1HMace;
            checkBox_TwoHandMace.Checked = j.tier2HMace;
            checkBox_OneHandSword.Checked = j.tier1HSword;
            checkBox_TwoHandSword.Checked = j.tier2HSword;
            checkBox_Bow.Checked = j.tierBow;
            checkBox_Claw.Checked = j.tierClaw;
            checkBox_Dagger.Checked = j.tierDagger;
            checkBox_Sceptre.Checked = j.tierSceptre;
            checkBox_Staff.Checked = j.tierStaff;
            checkBox_Wand.Checked = j.tierWand;
            checkBox_Quiver.Checked = j.tierQuiver;
            checkBox_Shield.Checked = j.tierShield;
            checkBox_BodyArmour.Checked = j.tierBody;
            checkBox_Boots.Checked = j.tierBoots;
            checkBox_Gloves.Checked = j.tierGloves;
            checkBox_Helmet.Checked = j.tierHelmet;

            foreach (var inc in j.tierBaseInclude)
            {
                dataGridView_BaseInclude.Rows.Add(imgDel, inc);
            }

            foreach (var exc in j.tierBaseExclude)
            {
                dataGridView_BaseExclude.Rows.Add(imgDel, exc);
            }
        }

        private void button_Close_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button_Save_Click(object sender, EventArgs e)
        {
            string json = File.ReadAllText($@"settings.json");
            dynamic jo = JsonConvert.DeserializeObject(json);

            JArray tierBaseInclude = new JArray();
            foreach (DataGridViewRow row in dataGridView_BaseInclude.Rows)
            {
                tierBaseInclude.Add(row.Cells[1].Value);
            }
            JArray tierBaseExclude = new JArray();
            foreach (DataGridViewRow row in dataGridView_BaseExclude.Rows)
            {
                tierBaseExclude.Add(row.Cells[1].Value);                                            
            }

            jo["tier1HAxe"] = checkBox_OneHandAxe.Checked;
            jo["tier2HAxe"] = checkBox_TwoHandAxe.Checked;
            jo["tierBow"] = checkBox_Bow.Checked;
            jo["tierClaw"] = checkBox_Claw.Checked;
            jo["tierDagger"] = checkBox_Dagger.Checked;
            jo["tier1HMace"] = checkBox_OneHandMace.Checked;
            jo["tier2HMace"] = checkBox_TwoHandMace.Checked;
            jo["tierSceptre"] = checkBox_Sceptre.Checked;
            jo["tierStaff"] = checkBox_Staff.Checked;
            jo["tier1HSword"] = checkBox_OneHandSword.Checked;
            jo["tier2HSword"] = checkBox_TwoHandSword.Checked;
            jo["tierWand"] = checkBox_Wand.Checked;
            jo["tierBody"] = checkBox_BodyArmour.Checked;
            jo["tierBoots"] = checkBox_Boots.Checked;
            jo["tierGloves"] = checkBox_Gloves.Checked;
            jo["tierHelmet"] = checkBox_Helmet.Checked;
            jo["tierShield"] = checkBox_Shield.Checked;
            jo["tierQuiver"] = checkBox_Quiver.Checked;

            jo["tierBaseInclude"] = tierBaseInclude;
            jo["tierBaseExclude"] = tierBaseExclude;
            string output = JsonConvert.SerializeObject(jo, Formatting.Indented);
            File.WriteAllText($@"settings.json", output);

            this.Close();
        }

        private void dataGrid_BaseInclude_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dataGridView_BaseInclude.CurrentCell.ColumnIndex.Equals(0))
            {
                dataGridView_BaseInclude.Rows.RemoveAt(dataGridView_BaseInclude.CurrentRow.Index);
            }
        }

        private void dataGrid_BaseExclude_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (dataGridView_BaseExclude.CurrentCell.ColumnIndex.Equals(0))
            {
                dataGridView_BaseExclude.Rows.RemoveAt(dataGridView_BaseExclude.CurrentRow.Index);
            }
        }

        private void pictureBox_AddBaseInclude_Click(object sender, EventArgs e)
        {
            dataGridView_BaseInclude.Rows.Add(imgDel, "");
        }

        private void pictureBox_AddBaseExclude_Click(object sender, EventArgs e)
        {
            dataGridView_BaseExclude.Rows.Add(imgDel, "");
        }
    }
}
